/*
 * kissdx - KiSS PC-Link Daemon eXtended (based on kissd)
 *
 * Copyright (C) 
 * Portions Copyright (C) 2006 Vidar Tysse <vidar@vidartysse.net>
 * Portions Copyright (C) 2007 Olivier Kahn <okahn@free.fr>
 *
 * Heavily based on kiss4lin,
 * Copyright (C) 2004 Jacob Kolding <dacobi@users.sourceforge.net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */
#ifndef CMCCLIENT_H_
#define CMCCLIENT_H_

// Communication between Master<=>Child (same host)
void deliver_local_command(const char* command);							// Local command ("hidden" feature)

// Communication between Server <=> Client over ADMCMD protocol (remote host supported)
void deliver_admcmd_action (char *admcmd_action, char *admcmd_cmd, char *param);	// Generic response to ADMCMD_ACTION request
int deliver_tcp_cmd(char *tcp_command,char *tcp_target_host, int tcp_port);	// Tooling : Create a TCP socket and send a command

// KiSS player Simulation over PCLINK Protocol
void simulplayer(char *tcp_player_command,char *tcp_player_param, char *tcp_response_expected);

void perform_admcmd_identity_request_reloadconfig(char *admcmd)	;			// admin command RELOAD_CONFIG via UDP requesting

struct sockaddr tcpFormatAdress( char * host, unsigned short port );

#endif /*CMCCLIENT_H_*/
